<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CountHousesUnderMngStartPeriod StructType
 * @subpackage Structs
 */
class CountHousesUnderMngStartPeriod extends AbstractStructBase
{
    /**
     * The count_houses_under_mng_start_period
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_houses_under_mng_start_period;
    /**
     * The serviced_by_tsg
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_tsg;
    /**
     * The serviced_by_tsg_uo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_tsg_uo;
    /**
     * The serviced_by_owner_uo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_owner_uo;
    /**
     * The serviced_by_competition
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_competition;
    /**
     * Constructor method for CountHousesUnderMngStartPeriod
     * @uses CountHousesUnderMngStartPeriod::setCount_houses_under_mng_start_period()
     * @uses CountHousesUnderMngStartPeriod::setServiced_by_tsg()
     * @uses CountHousesUnderMngStartPeriod::setServiced_by_tsg_uo()
     * @uses CountHousesUnderMngStartPeriod::setServiced_by_owner_uo()
     * @uses CountHousesUnderMngStartPeriod::setServiced_by_competition()
     * @param int $count_houses_under_mng_start_period
     * @param int $serviced_by_tsg
     * @param int $serviced_by_tsg_uo
     * @param int $serviced_by_owner_uo
     * @param int $serviced_by_competition
     */
    public function __construct($count_houses_under_mng_start_period = null, $serviced_by_tsg = null, $serviced_by_tsg_uo = null, $serviced_by_owner_uo = null, $serviced_by_competition = null)
    {
        $this
            ->setCount_houses_under_mng_start_period($count_houses_under_mng_start_period)
            ->setServiced_by_tsg($serviced_by_tsg)
            ->setServiced_by_tsg_uo($serviced_by_tsg_uo)
            ->setServiced_by_owner_uo($serviced_by_owner_uo)
            ->setServiced_by_competition($serviced_by_competition);
    }
    /**
     * Get count_houses_under_mng_start_period value
     * @return int|null
     */
    public function getCount_houses_under_mng_start_period()
    {
        return $this->count_houses_under_mng_start_period;
    }
    /**
     * Set count_houses_under_mng_start_period value
     * @param int $count_houses_under_mng_start_period
     * @return \StructType\CountHousesUnderMngStartPeriod
     */
    public function setCount_houses_under_mng_start_period($count_houses_under_mng_start_period = null)
    {
        // validation for constraint: int
        if (!is_null($count_houses_under_mng_start_period) && !(is_int($count_houses_under_mng_start_period) || ctype_digit($count_houses_under_mng_start_period))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_houses_under_mng_start_period, true), gettype($count_houses_under_mng_start_period)), __LINE__);
        }
        $this->count_houses_under_mng_start_period = $count_houses_under_mng_start_period;
        return $this;
    }
    /**
     * Get serviced_by_tsg value
     * @return int|null
     */
    public function getServiced_by_tsg()
    {
        return $this->serviced_by_tsg;
    }
    /**
     * Set serviced_by_tsg value
     * @param int $serviced_by_tsg
     * @return \StructType\CountHousesUnderMngStartPeriod
     */
    public function setServiced_by_tsg($serviced_by_tsg = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_tsg) && !(is_int($serviced_by_tsg) || ctype_digit($serviced_by_tsg))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_tsg, true), gettype($serviced_by_tsg)), __LINE__);
        }
        $this->serviced_by_tsg = $serviced_by_tsg;
        return $this;
    }
    /**
     * Get serviced_by_tsg_uo value
     * @return int|null
     */
    public function getServiced_by_tsg_uo()
    {
        return $this->serviced_by_tsg_uo;
    }
    /**
     * Set serviced_by_tsg_uo value
     * @param int $serviced_by_tsg_uo
     * @return \StructType\CountHousesUnderMngStartPeriod
     */
    public function setServiced_by_tsg_uo($serviced_by_tsg_uo = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_tsg_uo) && !(is_int($serviced_by_tsg_uo) || ctype_digit($serviced_by_tsg_uo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_tsg_uo, true), gettype($serviced_by_tsg_uo)), __LINE__);
        }
        $this->serviced_by_tsg_uo = $serviced_by_tsg_uo;
        return $this;
    }
    /**
     * Get serviced_by_owner_uo value
     * @return int|null
     */
    public function getServiced_by_owner_uo()
    {
        return $this->serviced_by_owner_uo;
    }
    /**
     * Set serviced_by_owner_uo value
     * @param int $serviced_by_owner_uo
     * @return \StructType\CountHousesUnderMngStartPeriod
     */
    public function setServiced_by_owner_uo($serviced_by_owner_uo = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_owner_uo) && !(is_int($serviced_by_owner_uo) || ctype_digit($serviced_by_owner_uo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_owner_uo, true), gettype($serviced_by_owner_uo)), __LINE__);
        }
        $this->serviced_by_owner_uo = $serviced_by_owner_uo;
        return $this;
    }
    /**
     * Get serviced_by_competition value
     * @return int|null
     */
    public function getServiced_by_competition()
    {
        return $this->serviced_by_competition;
    }
    /**
     * Set serviced_by_competition value
     * @param int $serviced_by_competition
     * @return \StructType\CountHousesUnderMngStartPeriod
     */
    public function setServiced_by_competition($serviced_by_competition = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_competition) && !(is_int($serviced_by_competition) || ctype_digit($serviced_by_competition))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_competition, true), gettype($serviced_by_competition)), __LINE__);
        }
        $this->serviced_by_competition = $serviced_by_competition;
        return $this;
    }
}
