<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HouseReport StructType
 * @subpackage Structs
 */
class HouseReport extends AbstractStructBase
{
    /**
     * The common
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\HouseReportCommon
     */
    public $common;
    /**
     * The communal_service
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\HouseReportCommunalService
     */
    public $communal_service;
    /**
     * The claims_to_consumers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\HouseReportClaimsToConsumers
     */
    public $claims_to_consumers;
    /**
     * The house_report_quality_of_work_claims
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\HouseReportQualityOfWorkClaims
     */
    public $house_report_quality_of_work_claims;
    /**
     * Constructor method for HouseReport
     * @uses HouseReport::setCommon()
     * @uses HouseReport::setCommunal_service()
     * @uses HouseReport::setClaims_to_consumers()
     * @uses HouseReport::setHouse_report_quality_of_work_claims()
     * @param \StructType\HouseReportCommon $common
     * @param \StructType\HouseReportCommunalService $communal_service
     * @param \StructType\HouseReportClaimsToConsumers $claims_to_consumers
     * @param \StructType\HouseReportQualityOfWorkClaims $house_report_quality_of_work_claims
     */
    public function __construct(\StructType\HouseReportCommon $common = null, \StructType\HouseReportCommunalService $communal_service = null, \StructType\HouseReportClaimsToConsumers $claims_to_consumers = null, \StructType\HouseReportQualityOfWorkClaims $house_report_quality_of_work_claims = null)
    {
        $this
            ->setCommon($common)
            ->setCommunal_service($communal_service)
            ->setClaims_to_consumers($claims_to_consumers)
            ->setHouse_report_quality_of_work_claims($house_report_quality_of_work_claims);
    }
    /**
     * Get common value
     * @return \StructType\HouseReportCommon|null
     */
    public function getCommon()
    {
        return $this->common;
    }
    /**
     * Set common value
     * @param \StructType\HouseReportCommon $common
     * @return \StructType\HouseReport
     */
    public function setCommon(\StructType\HouseReportCommon $common = null)
    {
        $this->common = $common;
        return $this;
    }
    /**
     * Get communal_service value
     * @return \StructType\HouseReportCommunalService|null
     */
    public function getCommunal_service()
    {
        return $this->communal_service;
    }
    /**
     * Set communal_service value
     * @param \StructType\HouseReportCommunalService $communal_service
     * @return \StructType\HouseReport
     */
    public function setCommunal_service(\StructType\HouseReportCommunalService $communal_service = null)
    {
        $this->communal_service = $communal_service;
        return $this;
    }
    /**
     * Get claims_to_consumers value
     * @return \StructType\HouseReportClaimsToConsumers|null
     */
    public function getClaims_to_consumers()
    {
        return $this->claims_to_consumers;
    }
    /**
     * Set claims_to_consumers value
     * @param \StructType\HouseReportClaimsToConsumers $claims_to_consumers
     * @return \StructType\HouseReport
     */
    public function setClaims_to_consumers(\StructType\HouseReportClaimsToConsumers $claims_to_consumers = null)
    {
        $this->claims_to_consumers = $claims_to_consumers;
        return $this;
    }
    /**
     * Get house_report_quality_of_work_claims value
     * @return \StructType\HouseReportQualityOfWorkClaims|null
     */
    public function getHouse_report_quality_of_work_claims()
    {
        return $this->house_report_quality_of_work_claims;
    }
    /**
     * Set house_report_quality_of_work_claims value
     * @param \StructType\HouseReportQualityOfWorkClaims $house_report_quality_of_work_claims
     * @return \StructType\HouseReport
     */
    public function setHouse_report_quality_of_work_claims(\StructType\HouseReportQualityOfWorkClaims $house_report_quality_of_work_claims = null)
    {
        $this->house_report_quality_of_work_claims = $house_report_quality_of_work_claims;
        return $this;
    }
}
